/*
 * @(#)ConsCollection.java  02/03/03
 */

/*
 * A class that defines the behavior of a constructed list of Comparables
 */

public class ConsCollection extends ACollectionList{

    /*--------------------------------------------------------
     Member data
     -------------------------------------------------------*/
    
    /* first item in this list */
    Comparable first; 
    
    /* the rest_list of this list */
    ACollectionList rest_list;
    
    /*--------------------------------------------------------
     Constructor
     -------------------------------------------------------*/
    public ConsCollection(Comparable n, ACollectionList alot){
        
        /* the first item in this list */
        this.first = n;
        
        /* the rest_list of this list */
        this.rest_list  = alot;
    }
    
   
  
    /*--------------------------------------------------------
     Produce a sorted list from this list of Comparables.
     -------------------------------------------------------*/
    ACollectionList sort(){
        return (rest_list.sort()).insert(first);
    }
    
    /*--------------------------------------------------------
     Insert a Comparable into this sorted list
     -------------------------------------------------------*/
     //change this method to work with Comparables
    ACollectionList insert(Comparable n){
        if (n.more_valuable(this.first)>0)
            return (new ConsCollection(n, this));
        else
            return (new ConsCollection(first, rest_list.insert(n)));
    }
    
    /*--------------------------------------------------------
     Finds a maximum Comparable in the list by making a call to 
     determine_most_valuable_Item_in_detail
     -------------------------------------------------------*/
   Comparable most_valuable(){
   
   		return this.rest_list.most_valuable_helper(this.first);
    }
    /*--------------------------------------------------------
     Returns the maximum of the list
     -------------------------------------------------------*/
    //change this method to work with Comparables\
    
   Comparable most_valuable_helper(Comparable most_valuable_so_far){
   	
    if (most_valuable_so_far.compare_value(this.first) < 0)
           return this.rest_list.most_valuable_helper(this.first);
    else
           return this.rest_list.most_valuable_helper(most_valuable_so_far);
    }
   		
    /*--------------------------------------------------------
     Print this list
     -------------------------------------------------------*/
    public String toString(){
        return "new " + getClass().getName() + "("
               + first + ",\n\t" + rest_list + ")";
    }
        
    
}
    
